%define srcname cppo

Summary:        Equivalent of the C preprocessor for OCaml programs
Name:           ocaml-cppo
Version:        1.6.8
Release:        4%{?dist}

License:        BSD
URL:            https://ocaml-community.github.io/cppo/
Source0:        https://github.com/ocaml-community/cppo/archive/v%{version}/%{srcname}-%{version}.tar.gz

BuildRequires: ocaml-ocamlbuild-devel
BuildRequires: ocaml >= 4.02.3 ocaml-dune ocaml-findlib

%description
Cppo is an equivalent of the C preprocessor targeted at the OCaml
language and its variants.

The main purpose of cppo is to provide a lightweight tool for simple
macro substitution (＃define) and file inclusion (＃include) for the
occasional case when this is useful in OCaml. Processing specific
sections of files by calling external programs is also possible via
＃ext directives.

The implementation of cppo relies on the standard library of OCaml and
on the standard parsing tools Ocamllex and Ocamlyacc, which contribute
to the robustness of cppo across OCaml versions.


%package ocamlbuild
Summary:        Preprocessing plugin for ocamlbuild
Requires:       %{name} = %{version}-%{release}
Requires:       ocaml-ocamlbuild


%description ocamlbuild
This package contains a plugin for ocamlbuild that enables calling cppo
at build time.  To use it, call ocamlbuild with the argument
`-plugin-tag package(cppo_ocamlbuild)`.


%prep
%autosetup -n %{srcname}-%{version}


%build
dune build %{?_smp_mflags} --verbose --profile release


%install
dune install --destdir=%{buildroot}

find %{buildroot}%{_libdir}/ocaml -name \*.ml -delete

rm -fr %{buildroot}%{_prefix}/doc


%check
dune runtest --profile release


%files
%license LICENSE.md
%doc Changes README.md
%{_bindir}/cppo
%{_libdir}/ocaml/cppo


%files ocamlbuild
%{_libdir}/ocaml/cppo_ocamlbuild/


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.6.8-4
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 08 2023 cunshunxia <cunshunxia@tencent.com> - 1.6.8-3
- Rebuilt for ocaml-findlib 1.9.6

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.6.8-2
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 cunshunxia <cunshunxia@tencent.com> - 1.6.8-1
- initial build
